#include <math.h>
#include <stdlib.h>
 
#if defined(__APPLE__)
  #include <OpenGL/gl.h>
  #include <OpenGL/glu.h>
  #include <GLUT/glut.h>
#else
  #if defined(WIN32) || defined(_WIN32) || defined(__WIN32__)
    #include <windows.h>
  #endif
  #include <GL/gl.h>
  #include <GL/glu.h>
  #include <GL/glut.h>
#endif
 
void onInitialization() {
}
 
void onDisplay() {
  glClear(GL_COLOR_BUFFER_BIT); // Letoroljuk a kepernyot (feketere)

  glBegin(GL_TRIANGLES);

  glVertex2f(-0.2f, 0.0f);
  glVertex2f(0.2f, 0.2f);
  glVertex2f(0.2f, 0.0f);

  glVertex2f(0.3f, 0.6f);
  glVertex2f(0.9f, 0.3f);
  glVertex2f(0.5f, 0.7f);

  glEnd();
  
  glutSwapBuffers(); // Frissitjuk az ablakot. Ennelkul nem latszodna az amit rajzoltunk
}
 
void onMouse(int, int, int, int) {
}
 
void onMouseMotion(int, int) {
}
 
void onKeyboard(unsigned char, int, int) {
}
 
void onKeyboardUp(unsigned char, int, int) {
}
 
void onIdle() {
  // Erre azert van szukseg mert nehany ablakkezelo (foleg linux-os)
  // magatol nem hivja meg az onDislay()-t egyszer se, ha csak kulon 
  // meg nem kerjuk erre. Windows-on erre a pár sorra nincs szükség.
  static bool first_call = true;
  if(first_call) {
    glutPostRedisplay();
    first_call = false;
  }
}
 
int main(int argc, char **argv) {
  glutInit(&argc, argv);
  glutInitWindowSize(600, 600);
  glutInitWindowPosition(100, 100);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
 
  glutCreateWindow("Grafika pelda program");
 
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
 
  onInitialization();
 
  glutDisplayFunc(onDisplay);
  glutMouseFunc(onMouse);
  glutIdleFunc(onIdle);
  glutKeyboardFunc(onKeyboard);
  glutKeyboardUpFunc(onKeyboardUp);
  glutMotionFunc(onMouseMotion);
 
  glutMainLoop();
 
  return 0;
}